%{
#define YYSTYPE double
#include <math.h>
%}

%define lr.type ielr
%define lr.default-reduction accepting

/* BISON Declarations */
%token INTEGER
%token ADDOP
%token MULTOP
%token OPENPAREN
%token CLOSEPAREN

/*
rules = [
         (nonterminals.EXPRESSION, [nonterminals.EXPRESSION, terminals.ADDOP,      nonterminals.TERM      ]),
         (nonterminals.EXPRESSION, [nonterminals.TERM                                              ]),
         (nonterminals.TERM,       [nonterminals.TERM,       terminals.MULTOP,     nonterminals.FACTOR    ]),
         (nonterminals.TERM,       [nonterminals.FACTOR                                            ]),
         (nonterminals.FACTOR,     [terminals.OPENPAREN,  nonterminals.EXPRESSION, terminals.CLOSEPAREN]),
         (nonterminals.FACTOR,     [terminals.INTEGER                                           ])
         ]
*/

/* Grammar follows */
%%

EXPRESSION:   EXPRESSION ADDOP TERM
            | TERM

TERM:         TERM MULTOP FACTOR
            | FACTOR

FACTOR:       OPENPAREN EXPRESSION CLOSEPAREN
            | INTEGER
%%